/*
 * Copyright 2007 Chris Roberts. All rights reserved.
 * Distributed under the terms of the MIT License.
 *
 * Authors:
 *		Chris Roberts, cpr420@gmail.com
 */

#include <StorageKit.h>
#include <SupportKit.h>

#include <be/add-ons/tracker/TrackerAddon.h>


const char *kTerminalCommand = "/boot/beos/apps/Terminal &";
// The trailing '&' is so that it forks to the background and doesn't block execution


void launch_terminal(BEntry *entry) {
	BPath path;

	if (entry->GetPath(&path) != B_OK)
		return;

	chdir(path.Path());

	system (kTerminalCommand);
}


void process_refs(entry_ref base_ref, BMessage *message, void *reserved) {
	BEntry entry;
	int32 index;
	entry_ref tracker_ref;

	for (index = 0; message->FindRef("refs", index, &tracker_ref) == B_OK; index++) {

		if (entry.SetTo(&tracker_ref, true) == B_OK) {
			// Pass 'true' as the traverse argument so that if the ref is a symbolic link
			// we get the target of the link to ensure that it actually exists

			if (entry.IsDirectory())
				launch_terminal(&entry);
		}

	}


	if (index == 0) {
		// No folders were selected so we'll use the base folder

		if (entry.SetTo(&base_ref) == B_OK)
			launch_terminal(&entry);

	}
}
